﻿

package com.core 
{
	
	
	import flash.display.*;
	import flash.geom.*;
	import flash.geom.ColorTransform;
	import flash.display.*;
	import flash.text.*;
	import flash.events.*; 
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import com.utils.*;


 
public class imageObject extends MovieClip
{
	private var id:int=0;
	private var iUrl:String="";
	private var iBitMap:Bitmap;
	private var iBitMapData:BitmapData;
	public var pubDate:Date;
	public var processedDate:int;
	private var iAverageColor:uint;
	private var iMC:MovieClip;
	public var red:int;
	public var green:int;
	public var blue:int;
	public var avColorRGB:Array;
	private var luminosity:int;
	private var hsv_hue:int;
	private var hsv_saturation:int;
	private var hsv_value:int;
	public var indexedColours:Array;
	public var uniqueColours:Array;
	public var uColours:Array;
	public var image_mc:MovieClip = new MovieClip();
	public var bullet:MovieClip = new MovieClip();
	private var t:TextField = new TextField();;
	private var loadedBitmap:Bitmap;
	private var imageLoader:MovieClip = new MovieClip();
	private var loader:Loader = new Loader();
	public var imageCold:Boolean;
	private var bgDataView:MovieClip = new MovieClip();
	public var prevailingColor:int;

 

public function imageObject(p_id:int,p_iUrl:String,p_date:Date)
{
	set_id(p_id);
	set_url(p_iUrl);
	set_date(p_date);
	set_pDate(p_date);

 
}
      
      
	
public function createMC(p_b:BitmapData):void {
	
	set_indexedColours(p_b);
	set_uniqueColours();
	
	
	loader.visible = false;
	image_mc.addChild(loader);
	
	bgDataView.graphics.beginFill(0x999999);
	bgDataView.graphics.drawRect(0, 0, 120, 70);
	bgDataView.alpha = 0.8;
	bgDataView.graphics.endFill();
	bgDataView.visible = false;
	image_mc.addChild(bgDataView);
	bgDataView.x += 15;
	bgDataView.y += 20;
	
	var f:Font = new Font1(); // Create a new instance of the Font1 symbol from the document's library.
	var tf:TextFormat = new TextFormat();// Create a new TextFormat object, and set the font property to the myFont object's fontName property. 
	tf.font = f.fontName;
	tf.size = 10;
	t.autoSize = TextFieldAutoSize.LEFT;// Create a new TextField object, assign the text format using the  defaultTextFormat property, and set the embedFonts property to true. 
	t.defaultTextFormat = tf;
	t.embedFonts = true;

	
	
	bullet.graphics.beginFill(0xFF0000);
	var colorTransform:ColorTransform = bullet.transform.colorTransform;
	var al:int = uniqueColours.length;
	colorTransform.color = uniqueColours[al-1].colour;
	//colorTransform.color = imageTools.averageColour(p_b);

	prepareBitmap(p_b);
	set_averageColor(colorTransform.color);
	prevailingColor=imageTools.prevailingColorFamily(colorTransform.color,this.red,this.green,this.blue);
	set_bitmap(p_b);
	
	t.visible = false;
	var s:String = "\n";
	t.text = "date:" + get_pDate().toString() + s + "hue: " + get_hue() + s + "value: " + get_value() + s + "cold: " + get_temperature() + s + "color family: " + this.prevailingColor + s + "R:" + this.red + " G:" + this.green + " B:"+ this.blue;
	//t.rotation+=-45;
	t.x += 10;
	bgDataView.addChild(t);

	bullet.graphics.drawCircle( 0 , 30 , 10 );
	bullet.graphics.endFill();
	bullet.transform.colorTransform = colorTransform;

	image_mc.addChild(bullet);

	image_mc.buttonMode = true;
	image_mc.useHandCursor = true;
	image_mc.addEventListener(MouseEvent.CLICK , viewImage);
	image_mc.addEventListener(MouseEvent.ROLL_OVER , viewData);
	
	
	
	writeTrace("+++createMC+++ al="+al);
	}
	

	
	
public function viewImage(e:MouseEvent):void{
	if(loader.visible==false){
		loader.visible = true;
		}else {
			loader.visible = false;
		}
	}
	
public function viewData(e:MouseEvent):void {
	t.visible = true;
	bgDataView.visible = true;

	image_mc.removeEventListener(MouseEvent.ROLL_OVER, viewData);
	image_mc.addEventListener(MouseEvent.ROLL_OUT, hideData, false, 0, true);
	}

public function hideData(e:MouseEvent):void {
	t.visible = false;
	bgDataView.visible = false;
		
	image_mc.removeEventListener(MouseEvent.ROLL_OUT, hideData);
	image_mc.addEventListener(MouseEvent.ROLL_OVER, viewData, false, 0, true);
	}

public function loadImage()  {  
	 writeTrace("+++loadImage+++");
	 loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadBitmap);   
	 loader.load(new URLRequest(get_url()));  
  } 
	
private function loadBitmap(e:Event):void  {  
	writeTrace("+++loadBitmap+++");
	 e.target.removeEventListener(Event.COMPLETE, loadBitmap);
	 loadedBitmap = new Bitmap(e.target.loader.contentLoaderInfo.content.bitmapData.clone());  
	loadMC(loadedBitmap);
	  }

private function loadMC(p_b:Bitmap){
	writeTrace("+++loadMC+++");
	createMC(p_b.bitmapData);
	set_temperature(p_b.bitmapData);
  }

public function prepareBitmap(p_bitmap:BitmapData):void{
	writeTrace("+++prepareBitmap+++");
	iBitMapData=p_bitmap;
	//  reduceColours(iBitMapData,16);
		  }

private function writeTrace(m:String):void {
	trace(m);
  }


/* SETTERS ------------------------------------------------------------------------------------------------------------------*/

private function set_date(p_date:Date):void{
	pubDate=p_date;
}

private function set_pDate(p_pDate:Date):void{
	processedDate=calcTools.processDate(p_pDate);
}

private function set_id(p_id:int):void{
	id=p_id;
}

private function set_url(p_iUrl:String):void{
	iUrl=p_iUrl;
}

public function set_bitmap(p_bitmap:BitmapData):void{
	writeTrace("+++IMAGEOBJECT:SET BITMAP+++");
	iBitMap=new Bitmap(p_bitmap.clone()); 
}
	  
public function set_averageColor(p_avcolor:uint):void{
	iAverageColor = p_avcolor;
	this.red = imageTools.extractRed(p_avcolor);
	this.green = imageTools.extractGreen(p_avcolor);
	this.blue = imageTools.extractBlue(p_avcolor);
	avColorRGB = [red, green, blue];
	set_hue();
	set_saturation();
	set_value();
	trace("IMAGE AV COLOUR: R="+this.red+" G="+this.green+" B="+this.blue);
  }
	  
public function set_movieclip(p_mc:MovieClip):void{
	iMC=new MovieClip();
	iMC=p_mc;
}

public function set_luminosity():void{
	luminosity=0.2126*this.red + 0.7152*this.green + 0.0722*this.blue;
}
		  
public function set_hue():void{
	var Max:int=calcTools.maxValue(avColorRGB) ;
	var Min:int=calcTools.minValue(avColorRGB) ;
	if( Max == red && green >= blue){
		hsv_hue = 60*(green - blue)/(Max - Min);
	}
	if( Max == red && blue > green){
		hsv_hue = 300 + 60*(blue - green)/(Max - Min);
	}
	if (Max == green){
		hsv_hue = 120 + 60*(blue - red)/(Max - Min);
	}
	if( Max == blue){
		hsv_hue = 240 + 60*(red - green)/(Max - Min) ;
	}
}

public function set_saturation():void{
	var Max:int=calcTools.maxValue(avColorRGB) ;
	var Min:int=calcTools.minValue(avColorRGB) ;
	hsv_saturation = (Max - Min) / get_value(); 
  }

public function set_value():void {
	hsv_value = calcTools.maxValue(avColorRGB) ;
  }
	  
public function set_temperature(p_b:BitmapData):void {
	imageCold=imageTools.isCold(p_b);
  }

	private function set_indexedColours(p_b:BitmapData):void {
	  indexedColours = imageTools.indexColours(p_b, true);
	  }

	private function set_uniqueColours():void {
	  uniqueColours = imageTools.uniqueColours(indexedColours, 4, 0.01);
	  }
	  
	  
/* GETTERS ------------------------------------------------------------------------------------------------------------------*/
	  
public function get_image_mc():MovieClip{
	return image_mc;
}

public function get_id():int{
	return id;
}

public function get_date():Date{
	return pubDate;
}

public function get_pDate():int{
	return processedDate;
}

public function get_url():String{
	return iUrl;
}
	  
public function get_bitmap():Bitmap{
	return iBitMap;
  }
  
public function get_bitmapdata():BitmapData {
	return iBitMapData;
  }

public function get_averageColor():uint {
	return iAverageColor;
  }
  
public function get_luminosity():int {
	return luminosity;
  }
 
public function get_temperature():Boolean {
	return imageCold;
	  }
	   
public function get_value():int{
	return hsv_value;
	}
			  
public function get_saturation():int{
	return hsv_saturation;
	}
	  
public function get_hue():int{
	return hsv_hue;
	}
	
public function get_firstuniquecolour():uint{
	return 0;//a_uniqueColours[0];
		}
		
public function get_firstindexedcolour():uint{
	return indexedColours[0];
		}

		public function get_prevailingColor():int {
			return prevailingColor;
			}

/*	IMPROVING COLOR FUNCTIONS ------------------------------------------------------------------------------------------------------------------*/

	
		  
	/**
		 * Calculates wether a BitmapData Object has more cold colors than warm ones
		 * 
		 * @param	source		The BitmapData Object to analyse
		 * @return	uint		The coldest colour in the BitmapData
		 */
		/*
		public  function isCold( p_b:BitmapData ):Boolean
		{
			reduceColours( p_b, 64 );
			var R:Number = 0;
			var G:Number = 0;
			var B:Number = 0;
			var n:Number = 0;
			var p:Number;
			
			for (var x:int = 0; x < p_b.width; x++) 
			{
				for (var y:int = 0; y < p_b.height; y++) 
				{
					p = p_b.getPixel(x, y);
					
					R += p >> 16 & 0xFF;
					G += p >> 8  & 0xFF;
					B += p       & 0xFF;
					
					n++
				}
			}
			
			R /= n;
			G /= n;
			B /= n;
			
			
			
			return B>R;
		}
	  */
	  /*

		
		public static function indexColours( source:BitmapData, sort:Boolean = true ):Array
			{
			trace("+++indexColours+++");
				var n:Object = {};
				var a:Array = [];
				var p:int;
			
				for (var x:int = 0; x < source.width; x++)
				{
					for (var y:int = 0; y < source.height; y++)
					{
						p = source.getPixel(x, y);
						n[p] ? n[p]++ : n[p] = 1;
					}
				}
			
				for (var c:String in n)
				{
					a.push ( { colour:c, count:n[c] } );
				}
			
				function byCount( a:Object, b:Object ):int
				{
					if ( a.count > b.count ) return 1;
					if ( a.count < b.count ) return -1;
					return 0;
				}
			
				return a.sort( byCount, Array.DESCENDING );
			}
		
		public static function similar( colour1:uint, colour2:uint, tolerance:Number = 0.01 ):Boolean
			{
				var RGB1:Object = Hex24ToRGB( colour1 );
				var RGB2:Object = Hex24ToRGB( colour2 );
			
				tolerance = tolerance * ( 255 * 255 * 3 ) << 0;
			
				var distance:Number = 0;
			
				distance += Math.pow( RGB1.red - RGB2.red, 2 );
				distance += Math.pow( RGB1.green - RGB2.green, 2 );
				distance += Math.pow( RGB1.blue - RGB2.blue, 2 );
			
				return distance <= tolerance;
			}
			
			public static function different( colour:uint, colours:Array, tolerance:Number = 0.01 ):Boolean
				{
					for (var i:int = 0; i < colours.length; i++)
					{
						if ( similar( colour, colours[i], tolerance ) )
						{
							return false;
						}
					}
					return true;
				}

		public static function uniqueColours( colours:Array, maximum:int, tolerance:Number = 0.01 ):Array
				{
					trace("+++uniqueColours+++");
					var unique:Array = [];
				
					for (var i:int = 0; i < colours.length && unique.length < maximum; i++)
					{
						if ( different( colours[i], unique, tolerance ) )
						{
							unique.push( colours[i] );
						}
					}
				
					return unique;
				}
		*/
	  
	 
	  
   }
}
