/**
* feedpeep v1.0 - An application for studying color data through time from RSS feeds.
* 
* @author Eva Casado de Amezua . e_luanco@uoc.edu . www.ellaing.com
* @version 1.0
* 
* This application is offered as is and licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License.
* Functions averageColour(), isCold(), different(), similar(), uniqueColours(), indexColours() and reduceColours() by Justin Windle (http://blog.soulwire.co.uk/ ).
*/

package com.utils {
	
	public class calcTools {
		
		public static function maxValue (a:Array):int {
			var mxm:int = a[0];
			for (var i=0; i<a.length; i++) {
				if (a[i]>=mxm) {
					mxm = a[i];
				}
			}
			return mxm;
		}
		
		public static function minValue (a:Array):int {
			var mn:int = a[0];
			for (var i=0; i<a.length; i++) {
				if (a[i]<=mn) {
				mn = a[i];
				}
			}
			return mn;
		}
		
		public static function processDate(d:Date):int {
			var sDate:String = d.toString();
			var months:Array = new Array('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
			var arrDate:Array = sDate.split(/\s/gi);
			var _strDate:String = arrDate[5]+" "+months.indexOf(arrDate[1])+" "+arrDate[2];
			var dYear:int = int(arrDate[5]) * 10000;
			var dMonth:int=int(months.indexOf(arrDate[1])+1)*100;
			var dDate:int = int(arrDate[2]);
			var dValue:int = dYear + dMonth + dDate;
			
			stringUtils.writeTrace(1,"YYYYMMDD",dValue);
			return dValue;
			}
	}
	
}
