/**
* feedpeep v1.0 - An application for studying color data through time from RSS feeds.
* 
* @author Eva Casado de Amezua . e_luanco@uoc.edu . www.ellaing.com
* @version 1.0
* 
* This application is offered as is and licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License.
* Functions averageColour(), isCold(), different(), similar(), uniqueColours(), indexColours() and reduceColours() by Justin Windle (http://blog.soulwire.co.uk/ ).
*/

package com.utils {

	import flash.text.*;
	
	public class stringUtils {
		
		public static function prepareTextField(t:String, cx:int, cy:int, s:int = 12):TextField {
			var txtField:TextField = new TextField();
			var f:Font = new Font1(); 
			var fontField:TextFormat = new TextFormat();
			fontField.font = f.fontName;
			fontField.size = s;
			txtField.autoSize = TextFieldAutoSize.LEFT;
			txtField.defaultTextFormat = fontField;
			txtField.embedFonts = true;
			txtField.text = t;
			txtField.textColor = 0xFFFFFF;
			txtField.x = cx + 60;
			txtField.y = cy + 30; 
			return txtField
			}
		
		public static function writeTrace(i:int, m:String, n = 0):void {
			var msg:String = "";
			switch(i) {
				case 0: 
					msg = "> " + m;
					break; 
				case 1:
					msg = "_ " + m +" = " + n.toString();
					break; 
				default:
					msg = "> " + m;
					break;	
				}
			trace(msg);
			}
	}
	
}
