/**
* feedpeep v1.0 - An application for studying color data through time from RSS feeds.
* 
* @author Eva Casado de Amezua . e_luanco@uoc.edu . www.ellaing.com
* @version 1.0
* 
* This application is offered as is and licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License.
* Functions averageColour(), isCold(), different(), similar(), uniqueColours(), indexColours() and reduceColours() by Justin Windle (http://blog.soulwire.co.uk/ ).
*/

package  com.utils {
	
	import flash.events.Event;
	
	public class imageLoadEvent extends Event {
		
		public static const LOAD_STARTED:String = "loadStarted";
		public static const LOAD_PROCESSING:String = "loadProcessing";
		public static const LOAD_COMPLETED:String = "loadCompleted";
		public static const LOAD_FAILED:String = "loadFailed";
		public var optionalParameters:Object;
		
		public function imageLoadEvent($type:String, $optionalParams:Object = null, $bubbles:Boolean = false, $cancelable:Boolean = false):void {
			super($type, $bubbles, $cancelable);
			this.optionalParameters = $optionalParams;
			}
		
		public override function clone():Event {
			return new imageLoadEvent(type, this.optionalParameters, bubbles, cancelable);
			}
	}
}